Index: waeup/trunk/src/waeup/utils/importexport.py
===================================================================
--- waeup/trunk/src/waeup/utils/importexport.py	(revision 3551)
+++ waeup/trunk/src/waeup/utils/importexport.py	(revision 4789)
@@ -1,3 +1,13 @@
+import re
 import csv
+import grok
+import cPickle
+import zope.xmlpickle
+from cStringIO import StringIO
+from xml.dom.minidom import Document, getDOMImplementation
+from zope.interface import Interface
+from waeup.csvfile.interfaces import ICSVFile
+from waeup.interfaces import (IWAeUPObject, IWAeUPExporter, IWAeUPXMLExporter,
+                              IWAeUPXMLImporter, IWAeUPCSVImporter)
 
 def readFile(f):
@@ -14,2 +24,77 @@
     writer = csv.writer(open("export.csv", "wb"))
     writer.writerows(data)
+
+class Exporter(grok.Adapter):
+    """Export a WAeUP object as pickle.
+
+    This all-purpose exporter exports attributes defined in schemata
+    and contained objects (if the exported thing is a container).
+    """
+    grok.context(IWAeUPObject)
+    grok.provides(IWAeUPExporter)
+
+    def __init__(self, context):
+        self.context = context
+
+    def export(self, filepath=None):
+        if filepath is None:
+            filelike_obj = StringIO()
+        else:
+            filelike_obj = open(filepath, 'wb')
+        exported_obj = cPickle.dump(self.context, filelike_obj)
+        filelike_obj.close()
+        return filelike_obj
+
+class XMLExporter(grok.Adapter):
+    """Export a WAeUP object as XML.
+
+    This all-purpose exporter exports XML representations of pickable
+    objects.
+    """
+    grok.context(Interface)
+    grok.provides(IWAeUPXMLExporter)
+
+    def __init__(self, context):
+        self.context = context
+    
+    def export(self, filepath=None):
+        pickled_obj = cPickle.dumps(self.context)
+        result = zope.xmlpickle.toxml(pickled_obj)
+        if filepath is None:
+            filelike_obj = StringIO()
+        else:
+            filelike_obj = open(filepath, 'wb')
+        filelike_obj.write(result)
+        filelike_obj.seek(0)
+        return filelike_obj
+
+class XMLImporter(grok.Adapter):
+    """Import a WAeUP object from XML.
+    """
+    grok.context(Interface)
+    grok.provides(IWAeUPXMLImporter)
+
+    def __init__(self, context):
+        self.context = context
+    
+    def doImport(self, filepath):
+        xml = None
+        if isinstance(filepath, basestring):
+            xml = open(filepath, 'rb').read()
+        else:
+            xml = filepath.read()
+        obj = zope.xmlpickle.loads(xml)
+        return obj
+
+
+class CSVImporter(grok.MultiAdapter):
+    grok.adapts(ICSVFile, IWAeUPObject)
+    grok.provides(IWAeUPCSVImporter)
+    grok.baseclass()  # We don't want this base to be registered really.
+
+    def __init__(self, csvfile, receiver):
+        self.csvfile = csvfile
+        self.receiver = receiver
+
+    def doImport(self):
+        pass
Index: waeup/trunk/src/waeup/widgets/__init__.py
===================================================================
--- waeup/trunk/src/waeup/widgets/__init__.py	(revision 4789)
+++ waeup/trunk/src/waeup/widgets/__init__.py	(revision 4789)
@@ -0,0 +1,2 @@
+"""JS-driven widgets for WAeUP.
+"""
Index: waeup/trunk/src/waeup/widgets/interfaces.py
===================================================================
--- waeup/trunk/src/waeup/widgets/interfaces.py	(revision 4789)
+++ waeup/trunk/src/waeup/widgets/interfaces.py	(revision 4789)
@@ -0,0 +1,12 @@
+##
+## interfaces.py
+"""Interfaces for widgets.
+"""
+from zope.interface import Interface
+
+class ITableProvider(Interface):
+    """A provider for tables.
+    """
+    def getTables():
+        """Get a tuple of tables.
+        """
Index: waeup/trunk/src/waeup/widgets/table.py
===================================================================
--- waeup/trunk/src/waeup/widgets/table.py	(revision 4789)
+++ waeup/trunk/src/waeup/widgets/table.py	(revision 4789)
@@ -0,0 +1,126 @@
+"""Table widget.
+"""
+import grok
+from hurry import yui
+from zope.interface import Interface
+from waeup.widgets.interfaces import ITableProvider
+
+def varName(string):
+    varname = string.lower()
+    return ''.join([x for x in varname
+                    if x in 'abcdefghijklmnopqrstuvwxyz_0123456789'])
+
+class Col(object):
+    """A column in a table.
+    """
+    header = 'Unnamed'
+    type = None
+    sortable = False
+    width = 100
+
+    def __init__(self, header=u'Unnamed', width=None, sortable=False,
+                 type=None, data=()):
+        self.header = header
+        self.width = width
+        self.sortable = sortable
+        self.type = type
+        self.data = data
+        self.key = varName(header)
+    
+class Table(object):
+    """A table.
+    """
+    def __init__(self, title=u'Unnamed', width=500, height=180, cols=()):
+        self.title = title
+        self.cols = cols
+        self.width = width
+        self.height = height
+        self.internal_title = varName(title)
+
+    def renderHTML(self):
+        result = '<div id="%s-tablecontainer"><table id="%s-table">' % (
+            self.internal_title, self.internal_title)
+        data_rows = self.getRows()
+        result += '<thead><tr>'
+        for col in self.cols:
+            result += '<th>%s</th>' % (col.header,)
+        result += '</tr></thead>\n'
+        result += '<tbody>'
+            
+        for row in data_rows:
+            result += '<tr>\n  '
+            for elem in row:
+                result += '<td>%s</td>' % elem
+            result += '\n</tr>'
+        result += '</tbody></table></div>'
+        return result
+
+    def getRows(self):
+        data_cols = (x.data for x in self.cols)
+        # turn rows into cols and vice versa:
+        # ((a, 1, p), (b, 2, q)) --> ((a, b), (1, 2), (p, q))
+        data_rows = tuple(map(lambda *x: (x), *data_cols))
+        return data_rows
+
+
+class YUITable(Table):
+    """A table that can generate JavaScript code for use with YUI.
+    """
+    def need(self):
+        yui.dragdrop.need() # datatable needs dragdrop loaded in advance.
+                            # This dependency is not defined yet in hurry.yui.
+        yui.paginator.need()
+        yui.datatable.need()
+        yui.sam.need()
+        yui.fonts.need()
+
+    def getJSTableCode(self, paginator=True):
+        title = self.internal_title
+        fielddefs = ",".join(['{key:"%s"}'%x.key for x in self.cols])
+        coldefs = ",".join([
+                '{key:"%s",label:"%s",sortable:%s}' % (
+                    x.key, x.header, str(x.sortable).lower())
+                for x in self.cols
+                ])
+        result = """
+YAHOO.util.Event.addListener(window, "load", function() {
+  var %sDataSource = new YAHOO.util.DataSource(YAHOO.util.Dom.get("%s-table"));
+  %sDataSource.responseType = YAHOO.util.DataSource.TYPE_HTMLTABLE;
+  %sDataSource.responseSchema = {
+    fields: [%s]
+  };
+
+  var %sColDefs = [%s];
+  var %sDataTable = new YAHOO.widget.DataTable("%s-tablecontainer",
+                                               %sColDefs, %sDataSource,
+                                               {
+paginator: new YAHOO.widget.Paginator({ 
+	                rowsPerPage: 15, 
+	                template: YAHOO.widget.Paginator.TEMPLATE_ROWS_PER_PAGE, 
+	                rowsPerPageOptions: [10,15,30,50,100], 
+	                pageLinks: 5 
+	            }), 
+draggableColumns:true });
+});
+""" % (
+            title, title, title, title, fielddefs, title, coldefs,
+            title, title, title, title)
+        return result
+
+
+    
+class YUIStaticTableView(grok.View):
+    grok.context(Interface)
+    grok.name('yuistatictables.js')
+
+    def render(self):
+        try:
+            provider = ITableProvider(self.context)
+        except:
+            # No table provider for the context. Be gentle...
+            return ''
+        self.response.setHeader('Content-Type',
+                                'text/javascript; charset=UTF-8')
+        tables = provider.getTables()
+        results = [table.getJSTableCode() for table in tables]
+        return '\n'.join(results)
Index: waeup/trunk/src/waeup/workflow.py
===================================================================
--- waeup/trunk/src/waeup/workflow.py	(revision 4789)
+++ waeup/trunk/src/waeup/workflow.py	(revision 4789)
@@ -0,0 +1,100 @@
+"""Workflows used in the WAeUP SRP portal.
+"""
+import grok
+from hurry.workflow.workflow import Transition, Workflow, WorkflowVersions
+from hurry.workflow.workflow import WorkflowInfo, WorkflowState, NullCondition
+from hurry.workflow.interfaces import MANUAL, AUTOMATIC, SYSTEM
+from hurry.workflow.interfaces import IWorkflow, IWorkflowState, IWorkflowInfo
+from hurry.workflow.interfaces import IWorkflowVersions
+from waeup.interfaces import IWAeUPObject
+
+UNCHECKED = 'unchecked'
+CHECKED = 'checked'
+
+def create_workflow():
+    init_transition = Transition(
+        transition_id = 'init',
+        title = 'Initialize',
+        source = None,
+        condition = NullCondition,
+        destination = UNCHECKED)
+
+    check_transition = Transition(
+        transition_id = 'check',
+        title = 'Check',
+        source = UNCHECKED,
+        destination = CHECKED)
+
+    final_transition = Transition(
+        transition_id = 'finalize',
+        title = 'Delete',
+        source = CHECKED,
+        destination = None)
+
+    return [init_transition, check_transition, final_transition]
+
+
+class WAeUPWorkflow(Workflow):
+    """A hurry.workflow Workflow with more appropriate error messages.
+    """
+    grok.provides(IWorkflow)
+    def __init__(self):
+        super(Workflow, self).__init__()
+        self.refresh(create_workflow())
+
+    def getTransition(self, source, transition_id):
+        from hurry.workflow.interfaces import\
+            InvalidTransitionError, ConditionFailedError
+
+        transition = self._id_transitions[transition_id]
+        if transition.source != source:
+            raise InvalidTransitionError(
+                "Transition '%s' requires '%s' as source state (is: '%s')" % (
+                    transition_id, transition.source, source))
+        return transition
+
+
+class WorkflowNullVersions(WorkflowVersions):
+    """A workflow versions manager that does not handle versions.
+
+    Sounds odd, but the default implementation of
+    :class:`hurry.workflow.workflow.WorkflowVersions` is a base
+    implementation that raises :exc:`NotImplemented` exceptions for
+    most of the methods defined below.
+
+    If we want to register a versionless workflow, an utility
+    implementing IWorkflowVersions is looked up nevertheless by
+    WorkflowInfo and WorkflowState components so we **have** to
+    provide workflow versions, even if we do not support versioned
+    workflows.
+
+    This implementation returns empty result sets for any requests,
+    but does not raise :exc:`NotImplemented`.
+    """
+    def getVersions(self, state, id):
+        return []
+
+    def getVersionsWithAutomaticTransitions(self):
+        return []
+
+    def hasVersion(self, id, state):
+        return False
+
+    def hasVersionId(self, id):
+        return False
+
+# Register global utilities for workflows and workflow versions...
+grok.global_utility(WAeUPWorkflow, IWorkflow)
+grok.global_utility(WorkflowNullVersions, IWorkflowVersions)
+
+class WorkflowState(grok.Adapter, WorkflowState):
+    """An adapter to adapt WAeUP objects to workflow states.
+    """
+    grok.context(IWAeUPObject)
+    grok.provides(IWorkflowState)
+    
+class WorkflowInfo(grok.Adapter, WorkflowInfo):
+    """Adapter to adapt WAeUP objects to workflow info objects.
+    """
+    grok.context(IWAeUPObject)
+    grok.provides(IWorkflowInfo)
